from time import sleep
import pymurapi as mur

auv = mur.mur_init()

#Задаём тягу 50 на мотор №0

sleep(1)

#Снимаем показания глубины, дистанции и угла 
angle, distance = auv.get_pinger_data(1)
depth = auv.get_depth()

#Погружаемся на определенную глубину до 2-х метров
while  depth < 2:
    depth = auv.get_depth()
    auv.set_motor_power(2, -30)
    auv.set_motor_power(3, -30)
    print(depth)
    
#Останавливаем погружение
auv.set_motor_power(2, 0)
auv.set_motor_power(3, 0)   
    

#Поворачиваемся в направлении маяка и плывем к ниму
i = 0  
while True:    
    angle, distance = auv.get_pinger_data(2)
    print(distance)
    if angle < 0:
        auv.set_motor_power(0, 0)
        auv.set_motor_power(1, 30)
    else:
        auv.set_motor_power(0, 30)
        auv.set_motor_power(1, 0) 
    #Если дистанция меньше 1.8 начинаем сбрасывать груз
    #Делаем 30 сбросов и переходим ко второй урне 
    
    if (distance < 1.8):
        auv.drop()  
        i = i + 1
        sleep(0.5)
    if i > 100:
        break          
    sleep(0.05)
    
#Поедем к другой урне и всплывем там
angle, distance = auv.get_pinger_data(3)
i = 0  
while distance > 1.8:    
    angle, distance = auv.get_pinger_data(3)
    print(distance)
    if angle < 0:
        auv.set_motor_power(0, 0)
        auv.set_motor_power(1, 30)
    else:
        auv.set_motor_power(0, 30)
        auv.set_motor_power(1, 0)
#Останавливаем движение        
auv.set_motor_power(0, 0)
auv.set_motor_power(1, 0)

#Всплываем
auv.set_motor_power(2, 30)
auv.set_motor_power(3, 30)
sleep(10)
    
        
    
    
